package cn.ibizlab.businesscentral.core.scheduling.service.impl;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.List;
import java.util.Set;
import java.util.Map;
import java.util.HashSet;
import java.util.HashMap;
import java.util.Collection;
import java.util.Objects;
import java.util.Optional;
import java.math.BigInteger;

import lombok.extern.slf4j.Slf4j;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.cglib.beans.BeanCopier;
import org.springframework.stereotype.Service;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.PageImpl;
import org.springframework.data.domain.Pageable;
import org.springframework.util.ObjectUtils;
import org.springframework.transaction.annotation.Transactional;
import org.springframework.context.annotation.Lazy;
import cn.ibizlab.businesscentral.core.scheduling.domain.RatingValue;
import cn.ibizlab.businesscentral.core.scheduling.filter.RatingValueSearchContext;
import cn.ibizlab.businesscentral.core.scheduling.service.IRatingValueService;

import cn.ibizlab.businesscentral.util.helper.CachedBeanCopier;


import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import cn.ibizlab.businesscentral.core.scheduling.mapper.RatingValueMapper;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.conditions.Wrapper;
import com.alibaba.fastjson.JSONObject;
import org.springframework.util.StringUtils;

/**
 * 实体[评分值] 服务对象接口实现
 */
@Slf4j
@Service("RatingValueServiceImpl")
public class RatingValueServiceImpl extends ServiceImpl<RatingValueMapper, RatingValue> implements IRatingValueService {

    @Autowired
    @Lazy
    private cn.ibizlab.businesscentral.core.scheduling.service.IBookableResourceCharacteristicService bookableresourcecharacteristicService;
    @Autowired
    @Lazy
    private cn.ibizlab.businesscentral.core.scheduling.service.IRatingModelService ratingmodelService;
    @Autowired
    @Lazy
    private cn.ibizlab.businesscentral.core.base.service.ITransactionCurrencyService transactioncurrencyService;

    private int batchSize = 500;

    @Override
    @Transactional
    public boolean create(RatingValue et) {
        if(!this.retBool(this.baseMapper.insert(et)))
            return false;
        CachedBeanCopier.copy(get(et.getRatingvalueid()),et);
        return true;
    }

    @Override
    public void createBatch(List<RatingValue> list) {
        this.saveBatch(list,batchSize);
    }

    @Override
    @Transactional
    public boolean remove(String key) {
        boolean result=removeById(key);
        return result ;
    }

    @Override
    public void removeBatch(Collection<String> idList) {
        removeByIds(idList);
    }

    @Override
    @Transactional
    public RatingValue get(String key) {
        RatingValue et = getById(key);
        if(et==null){
            et=new RatingValue();
            et.setRatingvalueid(key);
        }
        else{
        }
        return et;
    }

    @Override
    @Transactional
    public boolean update(RatingValue et) {
        if(!update(et,(Wrapper) et.getUpdateWrapper(true).eq("ratingvalueid",et.getRatingvalueid())))
            return false;
        CachedBeanCopier.copy(get(et.getRatingvalueid()),et);
        return true;
    }

    @Override
    public void updateBatch(List<RatingValue> list) {
        updateBatchById(list,batchSize);
    }

    @Override
    public RatingValue getDraft(RatingValue et) {
        return et;
    }

    @Override
    @Transactional
    public boolean save(RatingValue et) {
        if(!saveOrUpdate(et))
            return false;
        return true;
    }

    @Override
    @Transactional(
            rollbackFor = {Exception.class}
    )
    public boolean saveOrUpdate(RatingValue et) {
        if (null == et) {
            return false;
        } else {
            return checkKey(et) ? this.update(et) : this.create(et);
        }
    }

    @Override
    public boolean saveBatch(Collection<RatingValue> list) {
        saveOrUpdateBatch(list,batchSize);
        return true;
    }

    @Override
    public void saveBatch(List<RatingValue> list) {
        saveOrUpdateBatch(list,batchSize);
    }

    @Override
    public boolean checkKey(RatingValue et) {
        return (!ObjectUtils.isEmpty(et.getRatingvalueid()))&&(!Objects.isNull(this.getById(et.getRatingvalueid())));
    }

	@Override
    public List<RatingValue> selectByRatingmodel(String ratingmodelid) {
        return baseMapper.selectByRatingmodel(ratingmodelid);
    }

    @Override
    public void removeByRatingmodel(String ratingmodelid) {
        this.remove(new QueryWrapper<RatingValue>().eq("ratingmodel",ratingmodelid));
    }

	@Override
    public List<RatingValue> selectByTransactioncurrencyid(String transactioncurrencyid) {
        return baseMapper.selectByTransactioncurrencyid(transactioncurrencyid);
    }

    @Override
    public void removeByTransactioncurrencyid(String transactioncurrencyid) {
        this.remove(new QueryWrapper<RatingValue>().eq("transactioncurrencyid",transactioncurrencyid));
    }


    /**
     * 查询集合 DEFAULT
     */
    @Override
    public Page<RatingValue> searchDefault(RatingValueSearchContext context) {
        com.baomidou.mybatisplus.extension.plugins.pagination.Page<RatingValue> pages=baseMapper.searchDefault(context.getPages(),context,context.getSelectCond());
        return new PageImpl<RatingValue>(pages.getRecords(), context.getPageable(), pages.getTotal());
    }





    @Override
    public List<JSONObject> select(String sql, Map param){
        return this.baseMapper.selectBySQL(sql,param);
    }

    @Override
    @Transactional
    public boolean execute(String sql , Map param){
        if (sql == null || sql.isEmpty()) {
            return false;
        }
        if (sql.toLowerCase().trim().startsWith("insert")) {
            return this.baseMapper.insertBySQL(sql,param);
        }
        if (sql.toLowerCase().trim().startsWith("update")) {
            return this.baseMapper.updateBySQL(sql,param);
        }
        if (sql.toLowerCase().trim().startsWith("delete")) {
            return this.baseMapper.deleteBySQL(sql,param);
        }
        log.warn("暂未支持的SQL语法");
        return true;
    }

    @Override
    public List<RatingValue> getRatingvalueByIds(List<String> ids) {
         return this.listByIds(ids);
    }

    @Override
    public List<RatingValue> getRatingvalueByEntities(List<RatingValue> entities) {
        List ids =new ArrayList();
        for(RatingValue entity : entities){
            Serializable id=entity.getRatingvalueid();
            if(!ObjectUtils.isEmpty(id)){
                ids.add(id);
            }
        }
        if(ids.size()>0)
           return this.listByIds(ids);
        else
           return entities;
    }

}



